#include <stdio.h>
#include <highgui.h>

#define LIMIAR  100

int main( int argc, char** argv ) 
{
    IplImage* frame, *frame_copy = 0;
    uchar *data;
    int height,width,step,channels;
    int i,j,k;

    cvNamedWindow( "Original", CV_WINDOW_AUTOSIZE );
    cvNamedWindow( "Processed", CV_WINDOW_AUTOSIZE );
    CvCapture* capture = cvCreateFileCapture( argv[1] );

    frame = cvQueryFrame( capture );
    if( !frame ) exit;

    // get the image data
    height    = frame->height;
    width     = frame->width;
    step      = frame->widthStep;
    channels  = frame->nChannels;
    data = (uchar *)frame->imageData;
    printf("Processing a %dx%d image with %d channels\n",height,width,channels);   

    while(1) {
        frame = cvQueryFrame( capture );
        if( !frame ) break;
               
        cvShowImage( "Original", frame );

	if( !frame_copy )
                frame_copy = cvCreateImage( cvSize(frame->width,frame->height),
                                            IPL_DEPTH_8U, frame->nChannels );
     	if( frame->origin == IPL_ORIGIN_TL )
           	cvCopy( frame, frame_copy, 0 );
     	else
           	cvFlip( frame, frame_copy, 0 );

        for(i=0;i<height;i++) for(j=0;j<width;j++) 
	{
                if (i>=20 && i<=65 && j >=545 && j<=685)  // flir logo area
                {
		    data[i*step+j*channels+0]=0;          
		    data[i*step+j*channels+1]=0;
	            data[i*step+j*channels+2]=0;
		    continue;
		}

		if ((data[i*step+j*channels+0] >= LIMIAR) &&
		    (data[i*step+j*channels+1] >= LIMIAR) &&
			(data[i*step+j*channels+2] >= LIMIAR))
		{ 
			 data[i*step+j*channels+0]=255;          
			 data[i*step+j*channels+1]=255;
			 data[i*step+j*channels+2]=255;
		}
		if ((data[i*step+j*channels+0] < LIMIAR) &&
		    (data[i*step+j*channels+1] < LIMIAR) &&
			(data[i*step+j*channels+2] <= LIMIAR))
		{ 
			 data[i*step+j*channels+0]=0;          
			 data[i*step+j*channels+1]=0;
			 data[i*step+j*channels+2]=0;
		}
	}
  
        cvShowImage( "Processed", frame );

        char c = cvWaitKey(33);
        if( c == 27 ) break;
    }
    cvReleaseCapture( &capture );
    cvDestroyWindow( "Original" );
    cvDestroyWindow( "Processed" );
}
